	program main
	include 'mpif.h'
C       In MPI-2, you may be able to use an MPI module that will give
C       enhanced compile-time error checking
	integer rank, ierr
C
C 	This should use Fortran 90 derived types
C       struct { int a double b } value
	integer a
	double precision b
	integer mystruct, old_types(2)
	integer blocklens(2)
C       Use kind=MPI_ADDRESS_KIND in MPI-2
	integer indices(2)

	call MPI_Init( ierr )

	call MPI_Comm_rank( MPI_COMM_WORLD, rank, ierr )

C One value of each type
	blocklens(1) = 1
	blocklens(2) = 1
C The base types
	old_types(1) = MPI_INTEGER
	old_types(2) = MPI_DOUBLE_PRECISION
C The locations of each element
C In MPI-2, use MPI_Get_address instead
	call MPI_Address( a, indices(1), ierr )
	call MPI_Address( b, indices(2), ierr )
C Make relative
	indices(2) = indices(2) - indices(1)
	indices(1) = 0
	call MPI_Type_struct( 2, blocklens, indices, old_types, 
     *                        mystruct, ierr )
	call MPI_Type_commit( mystruct, ierr )
C
 10	continue
	if (rank .eq. 0) read *, a, b

	call MPI_Bcast( value, 1, mystruct, 0, MPI_COMM_WORLD, ierr )
	
	print *, 'Process ', rank, ' got ', a, ' and ', b
	if (a .ge. 0) goto 10

C Clean up the type 
	call MPI_Type_free( mystruct, ierr )
	call MPI_Finalize( ierr )
	end
