      program main
      include 'mpif.h'
      logical done
      integer n, myid, numprocs, i, ierr
      double precision pi25dt, mypi, pi, h, sum, x
      data pi25dt/3.141592653589793238462643/, done/.false./

      call mpi_init( ierr )

      call MPI_Comm_size( MPI_COMM_WORLD, numprocs, ierr )
      call MPI_Comm_rank( MPI_COMM_WORLD, myid, ierr )
 10   if (.not. done) then
         if (myid .eq. 0) then 
            print *, 'Enter the number of intervals: (0 quits) '
            read *, n
         endif
         call MPI_Bcast( n, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, ierr )
         if (n .eq. 0) goto 20
  
         h   = 1.0d0 / n
         sum = 0.0d0
         do 30 i=myid + 1, n, numprocs
	    x = h * (i - 0.5d0)
	    sum += 4.0d0 / (1.0d0 + x*x)
 30      continue
         mypi = h * sum
         
         call MPI_Reduce( mypi, pi, 1, MPI_DOUBLE_PRECISION, MPI_SUM, 0,
     &                    MPI_COMM_WORLD, ierr )
    
         if (myid .eq. 0) then
           print *, 'pi is approximately ', pi, ' Error is ', 
     &           abs(pi - PI25DT)
        endif
        goto 10
      endif
 20   continue
      call MPI_Finalize( ierr )
      stop
      end

